# -*- coding: utf-8 -*-
"""Feature generation & analysis.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1VKrkG9NsNVo76CVpbdP80QROQ05XYxpb
"""

import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
import numpy as np
from sklearn import datasets, ensemble
from sklearn.inspection import permutation_importance
from sklearn.metrics import mean_squared_error, mean_absolute_error
from sklearn.model_selection import train_test_split
from sklearn.metrics import explained_variance_score

from sklearn.linear_model import LinearRegression, Lasso, Ridge, SGDRegressor
from sklearn.tree import DecisionTreeRegressor
from sklearn.ensemble import RandomForestRegressor, AdaBoostRegressor, GradientBoostingRegressor
from xgboost import XGBRegressor
from sklearn.metrics import mean_squared_error

from sklearn.model_selection import train_test_split
from sklearn.linear_model import LogisticRegression
# Sklearn metrics
from sklearn.metrics import confusion_matrix
from sklearn.metrics import roc_auc_score
from sklearn.metrics import roc_curve
from sklearn.metrics import r2_score
from sklearn import metrics
# Grid search cross validation
from sklearn.model_selection import GridSearchCV
from sklearn.linear_model import LogisticRegression
from sklearn.model_selection import train_test_split

def analysis():
    df=pd.read_csv(r'C:\Users\snadal\PycharmProjects\ADSDB\Explotation_zone\dataset.csv')

    df=df.drop(columns=['Country Name', 'Year'])

    y=df['Life Ladder']
    X=df.drop(columns='Life Ladder')

    X.shape[0]


    X_train, X_test, y_train, y_test = train_test_split(X, y, test_size=0.2, random_state=0)



    models ={"Linear Regression":LinearRegression(),
              "Lasso":Lasso(),
              "Decision Tree": DecisionTreeRegressor(),
              "Random Forest":RandomForestRegressor(),
              "AdaBoostRegressor":AdaBoostRegressor(),
              "GradientBoosting":GradientBoostingRegressor(),
              "XGB": XGBRegressor()}
    data={}
    for name, model in models.items():
      model_fit=model.fit(X_train,y_train)
      y_pred=model_fit.predict(X_test)
      metrics=[mean_squared_error(y_test, y_pred),mean_absolute_error(y_test, y_pred),r2_score(y_test, y_pred)]
      data[name]=metrics

    metrics=pd.DataFrame.from_dict(data, orient='index', columns=['MSE', 'MAE','R2' ])

